
% Implementation of Quaternionic Local Ranking Binary Pattern (QLRBP) 
% Reference: Lan R, Zhou Y, Tang Y Y. Quaternionic Local Ranking Binary
% Pattern: A Local Descriptor of Color Images [J]. IEEE Transactions on Image Processing, 2016, 25(2): 566-579.
% Rushi Lan, rslan2012@gmail.com


clear, clc, close all
im = imread('exam5.png'); % im = imresize(im,[128 64]); figure, imshow(im);
weights = [0.4 0.4 0.6];

%%%% original wld code


% image = padarray(image, [1 1], 'symmetric');

% % image = rgb2gray(im);
% im = double(im)./255;
% imR = im(:,:,1); imG = im(:,:,2); imB = im(:,:,3); % figure,imshow(im_R);figure,imshow(im_G);figure,imshow(im_B);figure,imshow(im_gray);
% % d_image = double(image);
% % d_image_R = double(im_R);  d_image_G = double(im_G);  d_image_B = double(im_B);
% imQ = quaternion(imR, imG, imB);
% % imM = sqrt(imR.^2+imG.^2+imB.^2);
% rate1 = angle(imQ*quaternion(1,0,0));
% rate2 = angle(imQ*quaternion(0,1,0));
% rate3 = angle(imQ*quaternion(0,0,1));


%%%% qlrbp code

eim = padarray(im, [1 1], 'symmetric');

im = double(im)./255;  eim = double(eim)./255;

eR = im(:,:,1); eG = im(:,:,2); eB = im(:,:,3);

[mm nn cd] = size(eim);
im = quaternion(im(:,:,1), im(:,:,2), im(:,:,3));
eim = quaternion(eim(:,:,1), eim(:,:,2), eim(:,:,3));

imQ = abs(im);

alfa1 = weights(1);
alfa2 = weights(2);
alfa3 = weights(3);


%%% fast calculation
% t0 = cputime;

%%% the modulus
rate0 = abs(im);
figure,imshow(rate0,[]);

er = 1; eg = 0; eb = 0;   %% reference quaternion
part1 = alfa1*abs(eG*eb-eB*eg) + alfa2*abs(eB*er-eR*eb) + alfa3*abs(eR*eg-eG*er);
part2 = -(eR*er+eG*eg+eB*eb);
rate1 = atan2(part1,part2+eps);
figure,imshow(rate1,[]);

er = 0; eg = 1; eb = 0;   %% reference quaternion
part1 = alfa1*abs(eG*eb-eB*eg) + alfa2*abs(eB*er-eR*eb) + alfa3*abs(eR*eg-eG*er);
part2 = -(eR*er+eG*eg+eB*eb);
rate2 = atan2(part1,part2+eps);
figure,imshow(rate2,[]);

er = 0; eg = 0; eb = 1;   %% reference quaternion
part1 = alfa1*abs(eG*eb-eB*eg) + alfa2*abs(eB*er-eR*eb) + alfa3*abs(eR*eg-eG*er);
part2 = -(eR*er+eG*eg+eB*eb);
rate3 = atan2(part1,part2+eps);
figure,imshow(rate3,[]);

%%%% end

%%% then the traditional LBP can be implemented on rate0-rate3 for feature extraction






